import argparse
import random
import time

from pythonosc import udp_client

if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    parser.add_argument("--ip", default="127.0.0.1",
                        help="The ip of the OSC server")
    parser.add_argument("--port", type=int, default=8000,
                        help="The port the OSC server is listening on")
    args = parser.parse_args()

    client = udp_client.SimpleUDPClient(args.ip, args.port)

    for i in range(5):
        client.send_message("/config/age", int(100 * random.random()))
        time.sleep(0.5)
        client.send_message("/config/dir", (float(100 * random.random()), float(100 * random.random())))
        time.sleep(0.5)

